#------ Main loop of the datapack ------#

# Activates checkpoint if gold block under player's feet
execute as @a at @s if block ~ ~-1 ~ gold_block align xyz run function pb:checkpoint

execute as @a at @s if entity @s[y=0,dy=-16] at @e[type=armor_stand,tag=checkpoint,limit=1,sort=nearest] run tp @s ~ ~ ~

effect give @a resistance 1 100 true

#------ Mechanics tests ------#
# Increases stilltime #
execute as @a if score @s pb_stilltime < config pb_stilltime run scoreboard players add @s pb_stilltime 1

# Tests if the player is moving #
execute as @a store result score @s pb_posx run data get entity @s Pos[0] 10.0
execute as @a store result score @s pb_posz run data get entity @s Pos[2] 10.0

execute as @a run scoreboard players operation temp pb_prevposx = @s pb_posx
execute as @a run scoreboard players operation temp pb_prevposz = @s pb_posz

execute as @a run scoreboard players operation @s pb_posx -= @s pb_prevposx
execute as @a run scoreboard players operation @s pb_posz -= @s pb_prevposz

execute as @a if score @s pb_posx matches 0 if score @s pb_posz matches 0 run scoreboard players set @s pb_ismoving 0

# If moving, checks Wallrun #
execute as @a[scores={pb_ismoving=1..}] unless score @s pb_sneaktime matches 1.. unless score @s pb_limittime = config pb_limittime run function pb:wallrun

# If sneaking, checks Grab #
execute as @a[scores={pb_sneaktime=1..}] unless score @s pb_limittime = config pb_limittime run function pb:grab

# Removes remaining barriers if stilltime reaches the time specified in the config #
execute as @a if score @s pb_stilltime = config pb_stilltime run function pb:remove

# Resets and updates scoreboards after detection #
scoreboard players set @a pb_ismoving 1
scoreboard players set @a pb_sneaktime 0

execute as @a run scoreboard players operation @s pb_prevposx = temp pb_prevposx
execute as @a run scoreboard players operation @s pb_prevposz = temp pb_prevposz